﻿using Hi.Disp.Flag;
using Hi.Disp;
using Hi.Geom;
using Hi.Wpf.Disp;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hi.MongoUtils;
using Hi.Licenses;
using Hi.MachiningProcs;
using System.Windows.Forms;

namespace Hi.Sample.Wpf
{
    class Program
    {
        [STAThread]
        public static void Main(string[] args)
        {
            License.LogInAll();
            MongoServer.Default = MongoServer.Run(new MongoRunnerOptions()
            {
                MongoPort = 28100
            });

            var projectPath = "C:/HiNC-Projects/DemoStandardPath/Main.hincproj";
            Console.WriteLine($"Load Project: {projectPath}");
            MachiningCourse course = MachiningCourse.LoadFile(projectPath);
            course.PacePlayer.Start();

            Application.ApplicationExit += (object? sender, EventArgs e)=> {
                course.Dispose();
                MongoServer.Default.Dispose();
                License.LogOutAll();
            };

            var courseDisplayee = new MachiningCourseDisplayee(() => course);
            //courseDisplayee.RenderingFlagBitArray[(int)RenderingFlag.Mech] = true;
            courseDisplayee.RenderingFlagBitArray[(int)RenderingFlag.Fixture] = true;
            courseDisplayee.RenderingFlagBitArray[(int)RenderingFlag.WorkpieceGeom] = true;
            courseDisplayee.RenderingFlagBitArray[(int)RenderingFlag.ClStrip] = true;
            courseDisplayee.RenderingFlagBitArray[(int)RenderingFlag.DimensionBar] = true;

            RenderingWindow.RunApplication("Demo ", courseDisplayee);
        }

    }
}
